hdu1595 find the longest of the shortest(Dijkstra)

来源:互联网 发布:淘宝怎么切换类目 编辑:程序博客网 时间:2024/04/23 21:36

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1595


find the longest of the shortest

Time Limit: 1000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1665    Accepted Submission(s): 588


Problem Description
Marica is very angry with Mirko because he found a new girlfriend and she seeks revenge.Since she doesn't live in the same city, she started preparing for the long journey.We know for every road how many minutes it takes to come from one city to another.
Mirko overheard in the car that one of the roads is under repairs, and that it is blocked, but didn't konw exactly which road. It is possible to come from Marica's city to Mirko's no matter which road is closed.
Marica will travel only by non-blocked roads, and she will travel by shortest route. Mirko wants to know how long will it take for her to get to his city in the worst case, so that he could make sure that his girlfriend is out of town for long enough.Write a program that helps Mirko in finding out what is the longest time in minutes it could take for Marica to come by shortest route by non-blocked roads to his city.
 
Input
Each case there are two numbers in the first row, N and M, separated by a single space, the number of towns,and the number of roads between the towns. 1 ≤ N ≤ 1000, 1 ≤ M ≤ N*(N-1)/2. The cities are markedwith numbers from 1 to N, Mirko is located in city 1, and Marica in city N.
In the next M lines are three numbers A, B and V, separated by commas. 1 ≤ A,B ≤ N, 1 ≤ V ≤ 1000.Those numbers mean that there is a two-way road between cities A and B, and that it is crossable in V minutes.
 
Output
In the first line of the output file write the maximum time in minutes, it could take Marica to come to Mirko.
 
Sample Input
5 61 2 41 3 32 3 12 4 42 5 74 5 16 71 2 12 3 43 4 44 6 41 5 52 5 25 6 55 71 2 81 4 102 3 92 4 102 5 13 4 73 5 10
 
Sample Output
111327
 
Author
ailyanlu
 
Source
HDU 2007-Spring Programming Contest - Warm Up (1) 

题意:假设图中某条路径被堵死,它的最坏情况下的最短路径是多少?基本算法就是先求出最短路径,然后假设最短路径中的某一条边被堵死,再求最短路,取这些最短路的最大值即可。


代码如下:

#include <cstdio>#include <cmath>#include <cstring>#include <string>#include <cstdlib>#include <climits>#include <ctype.h>#include <queue>#include <stack>#include <vector>#include <deque>#include <set>#include <map>#include <iostream>#include <algorithm>using namespace std;#define PI acos(-1.0)#define INF 0x3fffffff//typedef long long LL;//typedef __int64 LL;#define MAXN 1017int mat[MAXN][MAXN];int n, m;int re[MAXN];//记录路径void init(){for(int i = 0; i <= n; i++){re[i] = 0;for(int j = 0 ; j <= n; j++){if(i == j)mat[i][j] = 0;elsemat[i][j] = INF;}}}int dijkstra (int f){int dis[MAXN];//记录到任意点的最短距离int mark[MAXN];//记录被选中的结点 int i,j,k = 0;for(i = 0 ; i <= n ; i++)//初始化所有结点,每个结点都没有被选中 mark[i] = 0;    for(i = 0 ; i <= n ; i++)    {        dis[i] = INF;    }//mark[1] = 1;    dis[1] = 0;//start为1    int min ;//设置最短的距离。     for(i = 1 ; i <= n; i++)    {        min = INF;        for(j = 1 ; j <= n;j++)        {            if(mark[j] == 0  && dis[j] < min)//未被选中的结点中,距离最短的被选中             {                min = dis[j] ;                k = j;            }        }        mark[k] = 1;//标记为被选中         for(j = 1 ; j <= n ; j++)        {            if( mark[j] == 0  && (dis[j] > (dis[k] + mat[k][j])))//修改剩余结点的最短距离             {                dis[j] = dis[k] + mat[k][j];if(f)re[j] = k;            }        }    }    return dis[n];    } int main(){int i, j;int a, b, v;while(~scanf("%d%d",&n,&m)){init();for(i = 0; i < m; i++){scanf("%d%d%d",&a,&b,&v);if(v < mat[a][b]){mat[a][b] = mat[b][a] = v;}}int ans = dijkstra(1);for(i = n; i != 1; i = re[i]){int t = mat[i][re[i]];mat[i][re[i]] = INF;mat[re[i]][i] = INF;int tt = dijkstra(0);//从0开始为了re[]不再记录路径if( ans < tt)ans = tt;mat[i][re[i]] = t;mat[re[i]][i] = t;}printf("%d\n",ans);}return 0;}


1 0
原创粉丝点击